# Xomponent

**Ruby based React rendering** system.

## Installation

Add this line to your application's Gemfile:

```ruby
gem 'Xomponent'
```

And then execute:

    $ bundle

Or install it yourself as:

    $ gem install Xomponent

## Usage

Write follow code example name 'app.rb'

```rb
require 'Xomponent/server'
require 'Xomponent/React'

class Hello
  def render
    <<-EOS
<script crossorigin src="https://unpkg.com/react@16/umd/react.development.js"></script>
<script crossorigin src="https://unpkg.com/react-dom@16/umd/react-dom.development.js"></script>
<div id="app"/>
<script>#{Xomponent::React.render_to_app(Xomponent::React.new('div', '"Hello Xomponent."'))}</script>
    EOS
  end
end

puts 'Run Xomponent server at 2998'
Xomponent::Server.new(2998, Hello.new)
```

And execute `ruby app.rb` and access to http://localhost:2998 in your browser.

More example code is https://github.com/myun2/Xomponent/blob/master/examples/app.rb

## Development

After checking out the repo, run `bin/setup` to install dependencies. You can also run `bin/console` for an interactive prompt that will allow you to experiment.

To install this gem onto your local machine, run `bundle exec rake install`. To release a new version, update the version number in `version.rb`, and then run `bundle exec rake release`, which will create a git tag for the version, push git commits and tags, and push the `.gem` file to [rubygems.org](https://rubygems.org).

## Contributing

Bug reports and pull requests are welcome on GitHub at https://github.com/[USERNAME]/Xomponent.

## License

The gem is available as open source under the terms of the [MIT License](https://opensource.org/licenses/MIT).
