require 'Xomponent/server'
require 'Xomponent/Document'
require 'Xomponent/Style'
require 'Xomponent/React'

class Example
  class Style < Xomponent::Style
    def initialize
      super
      reset!
      add :header, {
        "background-color" => "#1c1b1f",
        "color" => "#fff", "font-size" => "2em"
      }
      add :main, margin: "4px"
    end
  end

  class Document < Xomponent::Document
    def initialize
      super
      self.title_content = 'Xomponent'
      self.style_content = Example::Style.new.render
      self.head_inner =
        '<script crossorigin src="https://unpkg.com/react@16/umd/react.development.js"></script>' +
        '<script crossorigin src="https://unpkg.com/react-dom@16/umd/react-dom.development.js"></script>'
      self.script_content = Xomponent::React.render_to_id(app)
    end

    def app
      content = header.render + ',' + main.render
      Xomponent::React.new(:div, content, className: 'container')
    end

    def header
      Xomponent::React.new('header', '"Xomponent"')
    end

    def main
      Xomponent::React.new('main', '"Hello."')
    end
  end
end

puts 'Run Xomponent server at 2998'
Xomponent::Server.new(2998, Example::Document.new)
